% Solution to problem #8 in anti-resonance compensators. 

jm = 0.001; jl = 0.001; kk = 500; kv = 0.01; 
xpnf = 0.2; Ts = 0.0001; 

wp = sqrt(kk*(jm+jl)/jm/jl); wz = sqrt(kk/jl); 
xp = sqrt(kv*kv*(jm+jl)/4/kk/jm/jl); 
xz = sqrt(kv*kv/4/kk/jl); 
wnf = wp;  xznf = xp; 

% Using Matlab to design discrete time notch filter

num = [ 1 2*wnf*xznf wnf*wnf]; 
den = [ 1 2*wnf*xpnf wnf*wnf]; 

sysd = c2d(tf(num,den),Ts,'matched')
[numd1,dend1] = tfdata(sysd,'v') 

% Calculating coefficients K1-K5 (Eq. 8x.19)

K1 = 2*exp(-xpnf*wnf*Ts)*cos(wnf*Ts*sqrt(1-xpnf*xpnf));
K2 = exp(-2*xpnf*wnf*Ts);
K3 = exp(-(xpnf-xznf)*wnf*Ts);
K4 = 2*exp(-xpnf*wnf*Ts)*cos(wnf*Ts*sqrt(1-xznf*xznf));
K5 = exp(-(xpnf+xznf)*wnf*Ts);

numd2 = [K3 -K4 K5]
dend2 = [1 -K1 K2]